// Copyright (c) 2015 HigPen Works (Kenichiro Matsuura / Yuki Tsukasa). All rights reserved.
#pragma once
#include "Mover.h"

class CHitBox {
public:
	bool Up, Down, Left, Right;
	void Clear() { Up=Down=Left=Right=false; }
	operator bool() { return Up||Down||Left||Right; }
	CHitBox() { Clear(); }
	CHitBox(CMover* a, CMover* b, float corner=0) {
		Clear();
		CVector &ap=a->Position, &bp=b->Position, v=bp-ap, s=a->Scale+b->Scale, t=s-corner;
		auto hx=[&]()->bool {
			if (abs(v.X)<=t.X) {
				if (0<=v.Y && v.Y<=s.Y) Up=true, ap.Y=bp.Y-s.Y, a->Velocity.Y=0; else
				if (0>=v.Y && -v.Y<=s.Y) Down=true, ap.Y=bp.Y+s.Y, a->Velocity.Y=0;
				return true;
			} else return false;
		};
		auto hy=[&]()->bool {
			if (abs(v.Y)<=t.Y) {
				if (0<=v.X && v.X<=s.X) Right=true, ap.X=bp.X-s.X, a->Velocity.X=0; else
				if (0>=v.X && -v.X<=s.X) Left=true, ap.X=bp.X+s.X, a->Velocity.X=0;	
				return true;
			} else return false;
		};
		if (abs(v.X)<abs(v.Y)) hx()||hy(); else hy()||hx();
	}
	CHitBox(CMover* a, CMoverList& b, float corner=0) {
		Clear();
		b.Apply([&](CMover* m) {
			CHitBox h(a, m, corner);
			Up=Up||h.Up, Down=Down||h.Down, Right=Right||h.Right, Left=Left||h.Left;
		});
	}
};

